/*
   Driver para o Rastreador CyberTrack II! 
*/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <windows.h>


#include "../../SerialLib.h"
// ***************************************************
//
// ***************************************************
void ReadTrackerOrientation(char *data)
{
	char aux[100];
	int i;

	i=0;
	do{
		ReadStrFromSerial(aux, 1);
		data[i] = aux[0];
		if (aux[0] == '\0')
			break;
		//printf("%s", aux);
		i++;
	} while (1);
}

// ***************************************************
//
// ***************************************************
int CyberTrackOK()
{
	char Nome[10];

	ReadStrFromSerial(Nome, 3);
	if (strcmp(Nome, "CTM"))
	{
		return 0;
		exit(1);
	}
	else return 1;
}

// ***************************************************
//
// ***************************************************
void main(int argc, char *argv[])
{
    int baudrate = 9600;

	char Data[100];


    // Open the serial port.... (port, speed, timeout)
	// Sometimes it is necessary to change the timeout
	if (OpenSerialPort("COM1", 9600, 250) == -1) 
	{
        printf("Problemas na abertura da porta serial...\n");
        exit(1);
    }

    printf("Porta serial aberta.\n");

    // inicializa o tracker
	WriteSerialString("R");
	WriteSerialString("X");

	if (!CyberTrackOK())
	{
		printf("Problemas na inicializao do Cyber Track II.\n");
		exit(1);
	}
	else printf("Inicializao do Cyber Track II realizada com sucesso !\n");

	WriteSerialString("E"); // coloca o tracker em modo ASCII
	
	do{
		WriteSerialString("S"); // solicita um dado do tracker
		ReadTrackerOrientation(Data);
		printf("Dado lido do tracker: '%s'\n", Data);
	} while (!kbhit());


	CloseSerialPort();
	printf("Pressione ENTER para encerrar....");
	getchar();


}